package ch.epfl.tpp.sol;

import java.util.EmptyStackException;

public class LinkedStack<E> implements Stack<E> {
    private final Node<E> topNode;

    public static <E> Stack<E> emptyStack() {
        return new LinkedStack<>(null);
    }
    
    private LinkedStack(Node<E> topNode) {
        this.topNode = topNode;
    }
    
    @Override
    public boolean isEmpty() {
        return topNode == null;
    }

    @Override
    public int size() {
        int size = 0;
        for (Node<E> n = topNode; n != null; n = n.next)
            ++size;
        return size;
    }

    @Override
    public Stack<E> push(E newElem) {
        return new LinkedStack<E>(new Node<E>(newElem, topNode));
    }

    @Override
    public Stack<E> pop() {
        if (topNode == null)
            throw new EmptyStackException();
        return new LinkedStack<E>(topNode.next);
    }
    
    @Override
    public E top() {
        return topNode.value;
    }

    private static class Node<E> {
        public final E value;
        public final Node<E> next;
        
        public Node(E value, Node<E> next) {
            this.value = value;
            this.next = next;
        }
    }
}
